commit d2676e5ba020cf3b9b76411a8671f948d544f250
Author: freddy77 <freddy77>
Date:   Thu Dec 11 12:31:31 2008 +0000

    avoid some possible buffer overflows

diff --git a/ChangeLog b/ChangeLog
index c615d31..9491b0d 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Thu Dec 11 13:29:50 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/apps/Makefile.am src/apps/datacopy.c src/apps/freebcp.c:
+	* src/apps/freebcp.h:
+	- avoid some possible buffer overflows
+
 Thu Dec 11 11:11:34 CET 2008    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/unittests/cancel.c: add test for thread
 
@@ -1024,4 +1029,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2674 2008/12/11 10:14:19 freddy77 Exp $
+$Id: ChangeLog,v 1.2675 2008/12/11 12:31:31 freddy77 Exp $
diff --git a/src/apps/Makefile.am b/src/apps/Makefile.am
index 9e5c4d1..dd459c8 100644
--- a/src/apps/Makefile.am
+++ b/src/apps/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.27 2008/01/25 17:35:52 freddy77 Exp $
+# $Id: Makefile.am,v 1.28 2008/12/11 12:31:31 freddy77 Exp $
 
 AM_CPPFLAGS	= -I$(top_srcdir)/include 
 
@@ -16,7 +16,7 @@ endif
 
 dist_bin_SCRIPTS = osql
 
-freebcp_LDADD	= ../dblib/libsybdb.la $(NETWORK_LIBS)
+freebcp_LDADD	= ../dblib/libsybdb.la ../replacements/libreplacements.la $(NETWORK_LIBS)
 freebcp_SOURCES = freebcp.c freebcp.h
 
 tsql_LDADD	= ../tds/libtds.la \
diff --git a/src/apps/datacopy.c b/src/apps/datacopy.c
index 7ca73b3..cdab16c 100644
--- a/src/apps/datacopy.c
+++ b/src/apps/datacopy.c
@@ -171,10 +171,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 	int state;
 	int i;
 
-	char arg[FILENAME_MAX + 1];
-
-	char connection[256];
-	char owner[256];
+	char *arg;
 	char *tok;
 
 
@@ -187,7 +184,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 	state = GET_NEXTARG;
 
 	for (i = 1; i < argc; i++) {
-		strcpy(arg, argv[i]);
+		arg = argv[i];
 
 		switch (state) {
 
@@ -220,10 +217,9 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 				break;
 			case 'c':
 				pdata->cflag++;
-				if (strlen(arg) > 2) {
-					strcpy(owner, &arg[2]);
-					pdata->owner = strdup(owner);
-				} else
+				if (strlen(arg) > 2)
+					pdata->owner = strdup(&arg[2]);
+				else
 					state = GET_OWNER;
 				break;
 			case 'd':
@@ -232,9 +228,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 			case 'S':
 				pdata->Sflag++;
 				if (strlen(arg) > 2) {
-					strcpy(connection, &arg[2]);
-
-					tok = strtok(connection, "/");
+					tok = strtok(arg + 2, "/");
 					if (!tok)
 						return FALSE;
 					pdata->sserver = strdup(tok);
@@ -265,9 +259,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 			case 'D':
 				pdata->Dflag++;
 				if (strlen(arg) > 2) {
-					strcpy(connection, &arg[2]);
-
-					tok = strtok(connection, "/");
+					tok = strtok(arg + 2, "/");
 					if (!tok)
 						return FALSE;
 					pdata->dserver = strdup(tok);
@@ -316,14 +308,11 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 				fprintf(stderr, "If -c is specified an owner for the table must be provided.\n");
 				return FALSE;
 			}
-			strcpy(owner, arg);
-			pdata->owner = strdup(owner);
+			pdata->owner = strdup(arg);
 			state = GET_NEXTARG;
 			break;
 		case GET_SOURCE:
-			strcpy(connection, arg);
-
-			tok = strtok(connection, "/");
+			tok = strtok(arg, "/");
 			if (!tok)
 				return FALSE;
 			pdata->sserver = strdup(tok);
@@ -352,9 +341,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA * pdata)
 			break;
 
 		case GET_DEST:
-			strcpy(connection, arg);
-
-			tok = strtok(connection, "/");
+			tok = strtok(arg, "/");
 			if (!tok)
 				return FALSE;
 			pdata->dserver = strdup(tok);
diff --git a/src/apps/freebcp.c b/src/apps/freebcp.c
index 86d9a2b..60e03c7 100644
--- a/src/apps/freebcp.c
+++ b/src/apps/freebcp.c
@@ -41,11 +41,12 @@
 #endif
 
 #include "tds.h"
+#include "replacements.h"
 #include <sybfront.h>
 #include <sybdb.h>
 #include "freebcp.h"
 
-static char software_version[] = "$Id: freebcp.c,v 1.49 2008/05/28 20:08:48 freddy77 Exp $";
+static char software_version[] = "$Id: freebcp.c,v 1.50 2008/12/11 12:31:31 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 void pusage(void);
@@ -170,7 +171,7 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 	}
 
 	/* argument 2 - the direction */
-	strcpy(pdata->dbdirection, argv[2]);
+	tds_strlcpy(pdata->dbdirection, argv[2], sizeof(pdata->dbdirection));
 
 	if (strcmp(pdata->dbdirection, "in") == 0) {
 		pdata->direction = DB_IN;
@@ -184,7 +185,8 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 	}
 
 	/* argument 3 - the datafile name */
-	strcpy(pdata->hostfilename, argv[3]);
+	free(pdata->hostfilename);
+	pdata->hostfilename = strdup(argv[3]);
 
 	/* 
 	 * Get the rest of the arguments 
@@ -203,7 +205,8 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 			break;
 		case 'f':
 			pdata->fflag++;
-			strcpy(pdata->formatfile, optarg);
+			free(pdata->formatfile);
+			pdata->formatfile = strdup(optarg);
 			break;
 		case 'e':
 			pdata->eflag++;
@@ -262,7 +265,8 @@ process_parameters(int argc, char **argv, BCPPARAMDATA *pdata)
 			break;
 		case 'I':
 			pdata->Iflag++;
-			strcpy(pdata->interfacesfile, optarg);
+			free(pdata->interfacesfile);
+			pdata->interfacesfile = strdup(optarg);
 			break;
 		case 'S':
 			pdata->Sflag++;
diff --git a/src/apps/freebcp.h b/src/apps/freebcp.h
index d3793ed..8d77f86 100644
--- a/src/apps/freebcp.h
+++ b/src/apps/freebcp.h
@@ -1,4 +1,4 @@
-static char rcsid_freebcp_h[] = "$Id: freebcp.h,v 1.12 2006/10/06 21:28:20 jklowden Exp $";
+static char rcsid_freebcp_h[] = "$Id: freebcp.h,v 1.13 2008/12/11 12:31:31 freddy77 Exp $";
 static void *no_unused_freebcp_h_warn[] = { rcsid_freebcp_h, no_unused_freebcp_h_warn };
 
 enum states
@@ -33,10 +33,10 @@ typedef struct pd
 	char *dbobject;
 	char dbdirection[10];
 	DBINT direction;
-	char hostfilename[FILENAME_MAX + 1];
-	char formatfile[FILENAME_MAX + 1];
+	char *hostfilename;
+	char *formatfile;
 	char *errorfile;
-	char interfacesfile[FILENAME_MAX + 1];
+	char *interfacesfile;
 	int firstrow;
 	int lastrow;
 	int batchsize;

